//package abmland.models.infrastructure;
//
//import static abmland.common.CellDumbMock.ABooleanAllCells.requestBooleanAllCells;
//import static abmland.models.config.RasterIO.raster2boolmap;
//import static org.apache.log4j.Logger.getLogger;
//
//import java.util.HashMap;
//import java.util.HashSet;
//import java.util.Map;
//
//import org.apache.log4j.Logger;
//
//import repast.simphony.random.RandomHelper;
//import repast.simphony.space.grid.GridPoint;
//import abmland.data.CLCover;
//import abmland.data.Householdtypes;
////import abmland.models.config.InfrastructuretypeParameters;
//import abmland.models.config.InfrastructuretypeParameters;
//import abmland.types.IBooleanAllCells;
//import abmland.types.ICLCoverAllCells;
//import abmland.types.IHouseholdNumber;
//import abmland.types.IPressure;
//
//import com.moseph.gis.raster.Raster;
//
//public class PublicTransportProvider {
//
//	private Map<GridPoint, Boolean> PARAM_AVAILABILITY_MAP;
//
//	private final Logger log = getLogger(getClass().getName());
//
//	private float PARAM_DUMMY_PARAM;
//	
//	private int numberOfPublicTransportCells = 0;
//	private int numberOfInhabitedCells;
//
//	private InfrastructuretypeParameters params;
//	private Raster raster;
//
//	/**
//	 * Is called once per agent type by InfrastructureAgent
//	 */
//	protected final void init(InfrastructuretypeParameters params) {
//		log.trace(null);
//
//		this.params = params;
//		this.raster = params.getRaster();
//
//		PARAM_AVAILABILITY_MAP = raster2boolmap(raster);
//
//		PARAM_DUMMY_PARAM = params.minInhabitedAreaPerPublicTransportStop.floatValue();
//		// FIXME hier soll direkt ein anderer Wert eingelesen werden
//		
//		// get Number of patches with public transport from the raster
//		for (Boolean trueOnPatch : PARAM_AVAILABILITY_MAP.values()) {
//			numberOfPublicTransportCells += trueOnPatch ? 1 : 0;
//		}
//	}
//
//	/**
//	 * CLEVER mode
//	 * 
//	 * @param importedLandUse
//	 * @param importedPressure
//	 * @param importedTotalPopulationInHH
//	 */
//	public final void decideCLEVER(
//			ICLCoverAllCells importedLandUse,
//			Map<GridPoint, Map<CLCover, IPressure>> importedPressure,
//			Map<GridPoint, Map<Householdtypes, IHouseholdNumber>> importedTotalPopulationInHH) {
//		// if (NO_TEST_SCHEDULE) {
//
//		// step 1: use current stops and inhabited cells out of population
//		numberOfPublicTransportCells = computeNumberOfPublicTransportStopsInTMinus1();
//
//		log.trace("numberOfPublicTransportCells = "
//				+ numberOfPublicTransportCells);
//
//		// sum up hh number 
//		for (int x = 0; x <(int) importedLandUse.getDimensions().getWidth(); x++) {
//			for (int y = 0; y < (int) importedLandUse.getDimensions().getHeight(); y++) {
//				for (Householdtypes hhtype : Householdtypes.values()){
//					numberOfInhabitedCells += importedTotalPopulationInHH.get(new GridPoint(x, y)).get(hhtype).value();			
//				}
//			}
//		}
//		log.trace("numberOfInhabitedCells = " + numberOfInhabitedCells);
//
//		// step 2: plan enlargement because of demand
//		if (numberOfInhabitedCells / numberOfPublicTransportCells > PARAM_DUMMY_PARAM) {
//			log.trace("new public transport because of demand");
//			planNewPublicTransport(importedLandUse);
//		}
//		// step 3: inefficiency leads to closing
//		else if (numberOfInhabitedCells / numberOfPublicTransportCells < PARAM_DUMMY_PARAM) {
//			dismantlePublicTransport();
//			log.trace("dismantling of public transport");
//		}
//		else
//			;
//	}
//
//	/**
//	 * 
//	 * @return absolute number of public transport cells
//	 */
//	public int numOf() {
//		return numberOfPublicTransportCells;
//	}
//
//	private void dismantlePublicTransport() {
//		GridPoint randomLocation = PARAM_AVAILABILITY_MAP.keySet().iterator()
//				.next();
//		PARAM_AVAILABILITY_MAP.remove(randomLocation);
//	}
//
//	private void planNewPublicTransport(ICLCoverAllCells importedLandUse) {
//
//		GridPoint randomLocation = new GridPoint(0, 0);
//		Boolean locationFound = false;
//
//		Boolean newPublicTransportIsPossible = true;
//
//		while (locationFound == false) {
//
//			Boolean startingPointFound = false;
//			int counter = 0;
//
//			while (startingPointFound == false) {
//				randomLocation = new GridPoint(RandomHelper.nextIntFromTo(0,
//						PARAM_AVAILABILITY_MAP.keySet().iterator().next()
//								.getX()), RandomHelper.nextIntFromTo(0,
//						PARAM_AVAILABILITY_MAP.keySet().iterator().next()
//								.getY()));
//				counter++;
//
//				if (randomLocation.getX() > 0
//						&& randomLocation.getY() > 0
//						&& PARAM_AVAILABILITY_MAP.containsKey(randomLocation)
//						&& importedLandUse.get(randomLocation.getX(),
//								randomLocation.getY()) != CLCover.NO_DATA
//								.value()) {
//					startingPointFound = true;
//				} else if (counter > 50) {
//					newPublicTransportIsPossible = false;
//					log.trace("PublicTransp provider cannot build new stop!");
//					locationFound = true;
//					break;
//				}
//			}
//		}
//		if (newPublicTransportIsPossible == true) {
//
//			double landUseOnThisCell = importedLandUse.get(randomLocation
//					.getX(), randomLocation.getY());
//			if (landUseOnThisCell == CLCover.CONTINUOUS_URBAN_FABRIC.value()
//					| landUseOnThisCell == CLCover.DISCONTINUOUS_URBAN_FABRIC
//							.value()
//					| landUseOnThisCell == CLCover.CONSTRUCTION_SITES.value()
//					| landUseOnThisCell == CLCover.MULTI_STOREY_HOUSING.value()
//					| landUseOnThisCell == CLCover.NINETEENTH_CENTURY_TENEMENT
//							.value()
//					| landUseOnThisCell == CLCover.OTHER_MUNICIPAL_BUILDINGS
//							.value()
//					| landUseOnThisCell == CLCover.PREFAB_MULTI_STOREY.value()
//					| landUseOnThisCell == CLCover.SINGLE_HOUSE__VILLA.value()
//					| landUseOnThisCell == CLCover.TOWN_CENTRE.value())
//				locationFound = true;
//			PARAM_AVAILABILITY_MAP.put(randomLocation, true);
//			log.trace("new public transport on cell: " + randomLocation);
//		}
//	}
//
//	private int computeNumberOfPublicTransportStopsInTMinus1() {
//
//		int numberOfStops = 0;
//
//		for (GridPoint cell : PARAM_AVAILABILITY_MAP.keySet()) {
//			if (PARAM_AVAILABILITY_MAP.get(cell).equals(true)) {
//				numberOfStops++;
//			}
//		}
//		return numberOfStops;
//	}
//
//	protected final IBooleanAllCells retrieveAvailabilityOfPublicTransportByAgent() {
//		return requestBooleanAllCells(PARAM_AVAILABILITY_MAP, "publictransport");
//	}
//
//}


package abmland.models.infrastructure;

import static abmland.common.CellDumbMock.ABooleanAllCells.requestBooleanAllCells;
import static abmland.common.LogExceptionHandler.handleException;
import static abmland.common.ScheduleProperties.NO_TEST_SCHEDULE;
import static abmland.models.config.RasterIO.getRasterDimensions;
import static abmland.models.config.RasterIO.raster2boolmap;
import static org.apache.log4j.Logger.getLogger;

import java.util.HashMap;
import java.util.HashSet;
import java.util.Map;
import java.util.Set;

import org.apache.log4j.Logger;

import repast.simphony.random.RandomHelper;
import repast.simphony.space.grid.GridPoint;
import abmland.data.CLCover;
import abmland.data.Householdtypes;
import abmland.models.infrastructure.InfrastructureAgent.Env;
import abmland.models.config.InfrastructuretypeParameters;
import abmland.types.IBooleanAllCells;
import abmland.types.ICLCoverAllCells;
import abmland.types.IHouseholdNumber;
import abmland.types.IPressure;
import abmland.types.IProposalsSet;
import abmland.types.impl.HouseholdNumber;
import abmland.types.impl.ProposalsSet;

import com.moseph.gis.raster.Raster;

public class PublicTransportProvider {

	private Map<GridPoint, Boolean> PARAM_AVAILABILITY_MAP;
	private Map<GridPoint, HouseholdNumber> inhabitedCells;

	private final Logger log = getLogger(getClass().getName());

	private int numberOfPublicTransportCells = 0;
	private int hhNumber = 0;
	
	private InfrastructuretypeParameters params;
	private Raster raster;

	/**
	 * Is called once per agent type by InfrastructureAgent
	 */
	protected final void init(InfrastructuretypeParameters params) {
		log.trace(null);

		this.params = params;
		this.raster = params.getRaster();
//		log.error("PublicTransportProvider.init() raster.getCellsize() = " + raster.getCellsize());

		PARAM_AVAILABILITY_MAP = new HashMap<GridPoint, Boolean>();
		for (int x = 0; x <(int) raster.getRows(); x++) {
			for (int y = 0; y < (int) raster.getCols(); y++) {
				Boolean value;
				if (raster.getValue(x, y) == 1) 
					value = true;
				else value = false;
				PARAM_AVAILABILITY_MAP.put(new GridPoint(x, y), value );			
			}
		}
		
		for (Boolean trueOnPatch : PARAM_AVAILABILITY_MAP.values()) {
			numberOfPublicTransportCells += trueOnPatch ? 1 : 0;
		}
//		log.error ("numberOfPublicTransportCells in PublicTransportProvider.init() = " + numberOfPublicTransportCells);
		inhabitedCells = new HashMap<GridPoint, HouseholdNumber>();
	}

	/**
	 * CLEVER mode
	 * @param importedLandUse
	 * @param importedTotalPopulationInHH
	 */
	public final void decideCLEVER(
			ICLCoverAllCells importedLandUse,
			Map<GridPoint, Map<Householdtypes, IHouseholdNumber>> importedTotalPopulationInHH) {

		
			hhNumber = 0;
			// step 1: use current stops and inhabited cells out of population
			numberOfPublicTransportCells = computeNumberOfPublicTransportStopsInTMinus1();
			log.trace("numberOfPublicTransportCells = " + numberOfPublicTransportCells);

			// sum up hh number 
//			log.error("is imported land use null? " + (importedLandUse==null));
//			log.error("get dimensions is null? " + (importedLandUse.getDimensions()==null));
//			log.error("importedLandUse.getDimensions().size() :" + importedLandUse.getDimensions().size());
			for (int x = 0; x <(int) importedLandUse.getDimensions().getWidth(); x++) {
				for (int y = 0; y < (int) importedLandUse.getDimensions().getHeight(); y++) {
					for (Householdtypes hhtype : importedTotalPopulationInHH.get(new GridPoint(x,y)).keySet()){
						hhNumber += importedTotalPopulationInHH.get(new GridPoint(x, y)).get(hhtype).value();			
					}
				}
			}
			log.trace("household number in infrastructure agent = " + hhNumber);

			// step 2: plan enlargement because of demand
			if (hhNumber / numberOfPublicTransportCells > 600) {
//				log.trace("new public transport because of demand");
				planNewPublicTransport(importedLandUse);
			}

			// step 3: inefficiency leads to dismantling of bus stops
			else if (hhNumber / numberOfPublicTransportCells < 500) {
				dismantlePublicTransport(importedLandUse);		
//				log.trace("dismantle public transport");
			} 
			else ;
	}

	/**
	 * 
	 * @return absolute number of public transport cells
	 * for GUI Display
	 */
	public int numOf() {
//		log.error("number of bus stops for GUI : " + numberOfPublicTransportCells);
		return numberOfPublicTransportCells;
	}

	private void dismantlePublicTransport(ICLCoverAllCells importedLandUse) {
		
		Set<GridPoint> busStops = new HashSet<GridPoint>();
		
		for (int x = 0; x <(int) importedLandUse.getDimensions().getWidth(); x++) {
			for (int y = 0; y < (int) importedLandUse.getDimensions().getHeight(); y++) {
				if (PARAM_AVAILABILITY_MAP.get(new GridPoint(x, y))==true) {
					busStops.add(new GridPoint(x,y));
				}
			}
		}
		
		if (busStops.isEmpty()== false){
			
		GridPoint randomLocation = busStops.iterator().next();

		if (PARAM_AVAILABILITY_MAP.get(randomLocation) == true){
			PARAM_AVAILABILITY_MAP.put(randomLocation, false);}
		}  //else: no bus stops available
	}

	private void planNewPublicTransport(ICLCoverAllCells importedLandUse) {

		GridPoint randomLocation = new GridPoint(0, 0);
		Boolean newPublicTransportIsPossible = true;
		Boolean searchLocation = true;
		int counter = 0;
		
		while (searchLocation == true) {

				randomLocation = new GridPoint(
						RandomHelper.nextIntFromTo(0, PARAM_AVAILABILITY_MAP.keySet().iterator().next().getX()),
						RandomHelper.nextIntFromTo(0, PARAM_AVAILABILITY_MAP.keySet().iterator().next().getY()) );
				counter++;
//				log.error("random location = " + randomLocation.getX() + ", " + randomLocation.getY());

				if (randomLocation.getX() > 0
						&& randomLocation.getY() > 0
						&& PARAM_AVAILABILITY_MAP.containsKey(randomLocation)
						&& importedLandUse.get(randomLocation.getX(), randomLocation.getY()) != CLCover.NO_DATA.value()) 
				{
					searchLocation = false;
//					log.error("starting point found");
				} else if (counter > 50) {
					newPublicTransportIsPossible = false;
//				log.trace ("PublicTransp provider cannot build new stop!");
				searchLocation = false;
				}
			}

		
		if (newPublicTransportIsPossible == true){
				PARAM_AVAILABILITY_MAP.put(randomLocation, true);
//				log.trace("new public transport on cell: " + randomLocation);
				}
	}

	
	private int computeNumberOfPublicTransportStopsInTMinus1() {

		int numberOfStops = 0;

		for (GridPoint cell : PARAM_AVAILABILITY_MAP.keySet()) {
			if (PARAM_AVAILABILITY_MAP.get(cell).equals(true)) {
				numberOfStops++;
			}
		}
//		log.error ("number of public transport in t minus 1: " + numberOfStops);
		return numberOfStops;
	}



	protected final IBooleanAllCells retrieveAvailabilityOfPublicTransportByAgent() {
		return requestBooleanAllCells(PARAM_AVAILABILITY_MAP,
				"publictransport");
	}
}

