/**
 * Copyright (C) 2010 [[XYZ]], Helmholtz Centre for Environmental Research GmbH - UFZ <abmland@ufz.de>
 *
 *    Licensed under the Apache License, Version 2.0 (the "License");
 *    you may not use this file except in compliance with the License.
 *    You may obtain a copy of the License at
 *
 *        http://www.apache.org/licenses/LICENSE-2.0
 *
 *    Unless required by applicable law or agreed to in writing, software
 *    distributed under the License is distributed on an "AS IS" BASIS,
 *    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *    See the License for the specific language governing permissions and
 *    limitations under the License.
 */

package abmland.models.bindings;

import static org.apache.log4j.Logger.getLogger;

import org.apache.log4j.Logger;

import repast.simphony.context.Context;
import repast.simphony.dataLoader.ContextBuilder;

public class MainContextBuilder implements ContextBuilder<Object> {

	private final Logger log = getLogger(getClass().getName());

	private static Context<Object> mainContext;

	/**
	 * Create all agents in context.
	 */
	public Context<Object> build(Context<Object> context) {
		MainContextBuilder.mainContext = context;
		MainContextBuilder.mainContext = fillMainContext();
		return MainContextBuilder.mainContext;
	}

	/**
	 * FIXME
	 * **Only** needed when the _agents_ are needed to be initialized statically with
	 * constructor parameters... and not with model.score entries (Yes, adding a
	 * class reference to model.score actually initializes that class' object
	 * when starting Simphony&#8482; with RepastMain and the folder containing
	 * model.score as command line argument)
	 *
	 * @return
	 */
	private synchronized Context<Object> fillMainContext() {
		Context<Object> fullcontext = MainContextBuilder.mainContext;

		// fullcontext.add(new LandUseController(1));
		// fullcontext.add(new CostController());
		//
		// // XXX context wrapper still needed for agent loading??
		// fullcontext.addSubContext(new ResidentAgentContext());
		// fullcontext.addSubContext(new ResidentModelContext());
		// fullcontext.addSubContext(new BusinessAgentContext());
		// fullcontext.addSubContext(new BusinessModelContext());
		// fullcontext.addSubContext(new InfrastructureModelContext());
		// fullcontext.addSubContext(new PlannerModelContext());
		// fullcontext.addSubContext(new LobbyistModelContext());
		// fullcontext.addSubContext(new DeveloperModelContext());
		//
		// log.info("Added " + fullcontext.getSubContexts());

		return fullcontext;
	}
}
